#!/usr/bin/perl

################ Poll
#
# Copyright 1999 by Greg Billock
# Distributed under GPL
# Nicht ohne Erlaubnis weiterverteilen.
#
# Liest Abstimmungsdaten und ezeugt daraus eine HTML-Datei
#
# Aufrufeoptionen:
#	?poll=filename	- Dateiausgabe fuer die angegebene Datei
#
# 	?action=index	- Ausgabe des Index aller Abstimmungen
#
#	?action=display	- Ergebnisausgabe (kein Abstimmungsformular)
#
#	?action=ballot	- Ausgabe der Stimmzettelformular
#
#	?action=vote	- Abstimmformular
#
#	?action=addform	- Neue Abstimmung hinzufuegen
#
#	?action=briefdisplay	- fuer SSI-Darstellung
#	?action=briefballot	- fuer SSI-Stimmzettel
###########################

################################################################
# Konfiguration:
################################################################

# Logbuch mit den Verwaltungsdaten
$polldatafile = "./data/polls.txt";

# Domain
$domain = "http://www.gb-direkt.de";

# URL des Scripts
$selfurl = "$domain/cgi-bin/gb-direkt/abstimm/abstimm.cgi";

# Login fuer Administratorfunktionen (mit crypt verschluesselt)
$user = "Bigorajski";
$password = "74dwx5YgHUsxg";

# Titel
$title = "Abstimmung bei GB-Direkt";

# Der Bodytag
$bodystyle = qq<body background="$domain/images/sumtextb.jpg" bgcolor="#FFFFFF" text="#808080" link="#3333CC" vlink="#666699" alink="#990099">;

# Die Farbe fuer die ungeraden Zeilen der Ergebnistabelle
$odd = "bgcolor=" . $odd;

# Die Farbe fuer die geraden Zeilen der Ergebnistabelle
$even = "bgcolor=" . $even;

# Schriftfarbe innerhalb der geraden/ungeraden Zeilen
$oddcol = "#000000";
$evencol = "#808080";

# Der verwendete Font
$font = "verdana, arial, helvetica";

# Grafisches Trennzeichen
$separator = qq<p align="center"><img src="$domain/images/sumhorsa.gif" width="300" height=10"></p>;

# Grafikdatei mit rotem Punkt
$reddot = "$domain/images/rot.gif";


################################################################
# Programm:
################################################################

print "Content-type: text/html\n\n";

# IP-Adresse ermitteln
$remaddr = $ENV{"REMOTE_ADDR"};

&readparam;
$pollname = $form_data{'poll'};
$action = $form_data{'action'};

# Einlesen der Daten
&readdatafile;

$pollfile = $allpollfiles{$pollname};

if ($pollfile)
{
	$datafile = $pollfile;
	&readpollfile;
}

if ($action eq "")
{
	$action = "index";
}

if ($action eq 'index')
{
	&printhtmlhead;
	&printindex;
	&printhtmlfoot;
}

elsif ($action eq 'display')
{
	&printhtmlhead;
	&printdisplay;
	&printhtmlfoot;
}

elsif ($action eq 'ballot')
{
	&printhtmlhead;
	&printballot;
	&printhtmlfoot;
}

elsif ($action eq 'vote')
{
	&printhtmlhead;
	&printvoteresult;
	&printhtmlfoot;
}

elsif ($action eq 'briefdisplay')
{
	&printack;
	&printbriefdisplay;
}

elsif ($action eq 'briefballot')
{
	&printack;
	&printbriefballot;
}

elsif ($action eq 'addform')
{
	&printhtmlhead("Neue Abstimmung");
	&printaddform;
	&printhtmlfoot;
}

elsif ($action eq 'addpoll')
{
	&printhtmlhead;
	&processaddform;
	&printhtmlfoot;
}

elsif ($action eq 'admin')
{
	&printhtmlhead("Abstimmungsverwaltung");
	&printadminform;
	&printhtmlfoot;
}

########## Programmende #######


################################################################
# Subroutinen:
################################################################


# printadminform
# Ausgabe des Formulars zum Aendern des Status
sub printadminform
{
	&procadmin;


	print qq
<H3><A HREF="$selfurl?action=addform">Neue Abstimmung hinzufgen</A></H3>
<HR>
<H3>Verwalten existierender Abstimmungen</H3>

<FORM ACTION="$selfurl" METHOD="post">
	<INPUT TYPE="hidden" NAME="action" VALUE="admin">

<TABLE BORDER="4" CELLPADDING="5">
	;

	foreach $pname (@allpollnames)
	{
		#name
		print qq
	<TR>
		<TH ALIGN="left"><FONT FACE="$font">$allpolltitles{$pname}</TH>
		;

		# Aktiv/Inaktiv/Loeschen
		if ($allpollstatus{$pname} eq 'aktiv')
		{
			print qq
		<TD><FONT FACE="$font" SIZE="2">
		<INPUT TYPE="radio" NAME="$pname" VALUE="aktivieren" CHECKED>Aktivieren<BR>
		<INPUT TYPE="radio" NAME="$pname" VALUE="deaktivieren">Deaktivieren<BR>
		<INPUT TYPE="radio" NAME="$pname" VALUE="loeschen">Lschen
		</TD>
			;
		}
		else
		{
			print qq
		<TD><FONT FACE="$font" SIZE="2">
		<INPUT TYPE=\"radio\" NAME=\"$pname\" VALUE=\"aktivieren\">Aktivieren<BR>
		<INPUT TYPE=\"radio\" NAME=\"$pname\" VALUE=\"deaktivieren\" CHECKED>Deaktivieren<BR>
		<INPUT TYPE=\"radio\" NAME=\"$pname\" VALUE=\"loeschen\">Lschen
		</TD>
			;
		}

		# Ergebnisse betrachten
		print qq
		<TD ALIGN="center">
		<A HREF="$selfurl\?action=display\&poll=$pname">[Ergebnisse betrachten]</A></TD>
	</TR>
		;
	}

	print qq
</TABLE>
<P>Kennwort: <INPUT TYPE="text" NAME="submitpass"></P>
<P><INPUT TYPE="SUBMIT" VALUE="Abschicken"><BR>
</FORM>
$separator
<P ALIGN="center"><A HREF="$selfurl"><I>Zum Index</I></A></P>
	;
}

sub procadmin
{
	$submitpass = $form_data{'submitpass'};
	$submituser = $form_data{'submituser'};

	if ($submituser ne $user  || crypt($submitpass,$password) ne "$password")
	{
		return;
	}

	#figure out commands....

	@newpollnames = ();
	foreach $pname (@allpollnames)
	{
		$command = $form_data{$pname};
		if ($command eq 'aktivieren')
		{
			$allpollstatus{$pname} = "aktiv";
			@newpollnames = (@newpollnames, $pname);
		}
		if ($command eq 'deaktivieren')
		{
			$allpollstatus{$pname} = "inaktiv";
			@newpollnames = (@newpollnames, $pname);
		}
		if ($command eq 'loeschen')
		{
			delete $allpollstatus{$pname};
			delete $allpolltitles{$pname};
			delete $allpollfiles{$pname};
		}

	}

	@allpollnames = @newpollnames;

	&writedatafile;
}

# printaddform
# Gibt das Formular aus, um eine Abstimmung hinzuzufuegen
sub printaddform
{
	print qq
<FORM ACTION="$selfurl" METHOD="post">
	<INPUT TYPE="hidden" NAME="action" VALUE="addpoll">
<DIV ALIGN="center"><CENTER>
<TABLE BORDER="0">
	<TR>
		<TH ALIGN="left"><FONT FACE="$font">Name der Abstimmung (ein Wort):</FONT></TH>
		<TD><INPUT TYPE="text" NAME="newpoll" SIZE="50"></TD>
	</TR>
	<TR>
		<TH ALIGN="left"><FONT FACE="$font">Titel der Abstimmung: </TH>
		<TD><INPUT TYPE="text" NAME="title" SIZE="50"></TD>
	<TR>
		<TH ALIGN="left"><FONT FACE="$font">Dateiname fr die Abst.:</FONT></TH>
		<TD><INPUT TYPE="text" NAME="filename" SIZE="50"></TD>
	<TR>
		<TH ALIGN="left"><FONT FACE="$font">Abstimmungsfrage:</FONT></TH>
		<TD><INPUT TYPE="text" NAME="question" SIZE="50"></TD>
	<TR>
		<TH ALIGN="left"><FONT FACE="$font">Abstimmungsoptionen (eine pro Zeile):</FONT></TH>
		<TD><TEXTAREA NAME="options" ROWS="6" COLS="50"></TEXTAREA></TD>
	</TR>
	<TR>
		<TD ALIGN="center" COLSPAN="2">$separator</TD>
	</TR>
	<TR>
		<TH ALIGN="left"><FONT FACE="$font">Benutzer/Kennwort:</FONT></TH>
		<TD><INPUT TYPE="text" NAME="submituser" SIZE="24">
		<INPUT TYPE="password" NAME="submitpass" SIZE="24"></TD>
	</TR>
	<TR>
		<TD COLSPAN="2">$separator</TD>
	</TR>
	<TR>
		<TD ALIGN="center" COLSPAN="2"><INPUT TYPE="submit" VALUE="Neue Abstimmung hinzuf&uuml;gen"></TD>
	</TR>
</TABLE>
</CENTER></DIV>
</FORM>
	;
}


# processaddform
# Gibt eine Bestaetigung fuer das Bearbeiten des 
# Formulars zum Hinzufeugen einer Abstimmung aus
sub processaddform
{
	$pollname=$form_data{'newpoll'};
	$polltitle = $form_data{'title'};
	$datafile = "./data/" . $form_data{'filename'};
	$pollquestion= $form_data{'question'};
	$newpolloptions = $form_data{'options'};

	$submitpass = $form_data{'submitpass'};
	$submituser = $form_data{'submituser'};

	$submitpass = $form_data{'submitpass'};
	$submituser = $form_data{'submituser'};

	if ($submituser ne $user  || crypt($submitpass,$password) ne "$password")
	{
		print qq<H3 ALIGN="center"><FONT FACE="$font" COLOR="#CC0033">Leider inkorrektes Login. Es wurden keine nderungen aufgezeichnet.</FONT></H3>\n;
		return;
	}

	@options = split(/\n/,$newpolloptions);

	@polloptions = (" ", @options);
	$pollnumoptions = scalar(@polloptions) - 1;

	for ($i = 1; $i <= $pollnumoptions; $i++)
	{
		$pollvotes[$i] = 0;
	}

	# Schreiben der neuen Daten in die neue Datei
	&writepollfile;

	open(DATA, ">>$polldatafile");

	print (DATA "name=$pollname\n");
	print (DATA "title=$polltitle\n");
	print (DATA "file=$datafile\n");
	print (DATA "status=aktiv\n");

	close(DATA);

	# Bestaetigung an den Benutzer
	print qq
<H3 ALIGN="center"><FONT FACE="$font" COLOR="#CC0033">nderungen aufgezeichnet!</FONT></H3>
Um die neue Abstimmung zu betrachten, klicken Sie 
<A HREF="$selfurl?poll=$pollname&action=display">hier</A><P>
	;
}


# printvoteresult
# Gibt eine Abstimmungsdatei aus, nachdem eine Stimmabgabe aufgezeichnet wurde
sub printvoteresult
{
	&readpollfile;
	$mayvote = 1;

	foreach $ips (@pollips)
	{
		if ($remaddr eq $ips)
		{
			$mayvote = 0;
			last;
		}
	}

	if($mayvote == 1)
	{
		$votedoption = $form_data{'option'};
		$pollvotes[$votedoption]++;
		$tally++;
		&writepollfile;

		&printdisplay;
	}
	else
	{
		print qq
<H1 ALIGN="center"><I><FONT FACE="$font" COLOR="#FF0000">Sie haben Ihre Stimme<br>fr diese Abstimmung<br>bereits abgegeben!</FONT></I></H3>
<H3 ALIGN="center"><FONT FACE="$font" COLOR="#003366">IP-Adresse = $remaddr</FONT></H3>
<P>&nbsp;</P>
<P>&nbsp;</P>
<P ALIGN="center"><A HREF="$selfurl">Weitere Abstimmungen</></P>
		;
	}
}


#printindex
# Gibt einen Index aller existierenden Abstimmungen aus
sub printindex
{
	&readdatafile;

	print qq
<DIV ALIGN="center"><CENTER>
<TABLE BORDER="4" CELLPADDING="10" COLS="1">
	<TR>
		<TD>
		<H3 ALIGN="center"><FONT FACE="$font" COLOR="#00CC33">Aktuelle Abstimmungen:</H3>
		<CENTER>
		<TABLE BORDER="0" CELLSPACING="5" CELLPADDING="5" WIDTH="90%">
	;

	# Den ersten Punkt hervorheben
	$firstpoll = shift(@allpollnames);

	$curpollbgcolor = "#FFCCFF";
	print qq
			<TR>
				<TD BGCOLOR="$curpollbgcolor"><FONT FACE="$font"><B>$allpolltitles{$firstpoll}</B></FONT></TD>
				<TD ALIGN=CENTER BGCOLOR="$curpollbgcolor"><FONT FACE="$font"><A HREF="$selfurl?action=ballot&poll=$firstpoll">[Abstimmen!]</A></FONT></TD>
				<TD ALIGN=CENTER BGCOLOR="$curpollbgcolor"><FONT FACE="$font"><A HREF="$selfurl?action=display&poll=$firstpoll">[Ergebnisse]</A></FONT></TD>
			</TR>
	;

	# Der Rest der Abstimmungen ...
	foreach $pname (@allpollnames)
	{
		print qq
			<TR>
				<TD><FONT FACE="$font"><B>$allpolltitles{$pname}</B></FONT></TD>
				<TD ALIGN="CENTER">;

		if ($allpollstatus{$pname} eq 'aktiv')
		{
  			print "<FONT FACE=\"$font\"><A HREF=\"$selfurl?action=ballot&poll=$pname\">[Abstimmen!]</A></FONT></TD>\n";
		}
		else
		{
			print "<FONT FACE=\"$font\" COLOR=\"#CCCCCC\">[Inaktiv]</FONT></TD>\n";
		}
		print qq
				<TD ALIGN="center"><A HREF="$selfurl?action=display&poll=$pname">[Ergebnisse]</A></TD>
			</TR>
		;
	}

	print qq
		</TABLE>
		</CENTER>
		<BR>&nbsp;
		</TD>
	</TR>
</TABLE>
</CENTER></DIV>
	;
}

# printbriefdisplay
# Ausgabe der Abstimmungsdatei in eine Tabelle (fuer SSI-Ausgabe)
sub printbriefdisplay
{
	print "<B>$polltitle</B>\n";
	print "<P><I>$pollquestion</I><BR>\n";

	for($i=1; $i<=$pollnumoptions; $i++)
	{
		print "$polloptions[$i]: <B>$pollvotes[$i]</B><BR>\n";
	}
}


# printdisplay
# Ausgabe einer Abstimmungsdatei
sub printdisplay
{
	print qq
<DIV ALIGN="center"><CENTER>
<H3 ALIGN="center"><I><FONT FACE="$font" COLOR="#003366">Abstimmungsergebnisse fr ....</FONT></I></H3>
<TABLE BORDER="4" CELLPADDING="15">
	<TR>
		<TD><FONT FACE="$font"><B>$polltitle</B>
		<P><I>$pollquestion</I><BR>
		$separator
		<CENTER>
		<TABLE BORDER="0" CELLSPACING="5" CELLPADDING="5">
	;

	# Ausagbe der Ergebnisse
	for($i=1; $i<=$pollnumoptions; $i++)
	{
		print qq
			<TR>
				<TD><FONT FACE="$font" SIZE="2">$polloptions[$i]</FONT></TD>
				<TD WIDTH="20">&nbsp;</TD>
		;

		if ($tally != 0)
		{
			$percent = $pollvotes[$i] / $tally;
		}
		else
		{
			$percent = 0;
		}
		$percent = $percent * 100;
		$percent = int($percent);
		$rest = 100 - $percent;
		$grammar = $pollvotes[$i] == 1 ? "Stimme" : "Stimmen";
		
		print qq
				<TD ALIGN="right" VALIGN="top"><FONT FACE="$font" SIZE="2"><B>$pollvotes[$i]</B></FONT></TD>
				<TD ALIGN="left" VALIGN="top"><FONT FACE="$font" SIZE="2">$grammar</FONT><TD>
				<TD ALIGN="right" VALIGN="top"><FONT FACE="$font" SIZE="2">($percent %)</FONT><TD>
				<TD VALIGN="top"><TABLE WIDTH="100" BORDER="2"><TR><TD><IMG SRC="$reddot" HEIGHT="10" WIDTH="$percent"></TD></TR></TABLE></TD>
			</TR>
		;
	}

	print qq
		</TABLE>
		</CENTER></FONT>
		$separator
		</TD>
	</TR>
</TABLE>
<P><FONT FACE="$font"><A HREF="$selfurl">Weitere Abstimmungen</A>
<CENTER></DIV>
	;
}


# printbriefballot
# *Kurze* Ausgabe eines Stimmzettels fuer eine Abstimmungsdatei
sub printbriefballot
{
	print qq
<B>$polltitle</B><P>
<I>$pollquestion</I><BR>

<FORM ACTION="$selfurl" METHOD="post">
	<INPUT TYPE="hidden" NAME="poll" VALUE="$pollname">
	<INPUT TYPE="hidden" NAME="action" VALUE="vote">
	;

	for($i=1; $i<=$pollnumoptions; $i++)
	{
		print "<INPUT TYPE=\"radio\" NAME=\"option\" VALUE=\"$i\">\n";
		print "$polloptions[$i]<BR>\n";
	}

	print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Abstimmen\">\n";
	print "</FORM>\n";
}


# printballot
# Ausgabe eines Stimmzettels fuer eine Abstimmungsdatei
sub printballot
{
	print qq
<DIV ALIGN="center"<CENTER>
<H3 ALIGN="center"><I><FONT FACE="$font" COLOR="#003366">Bitte whlen Sie!</FONT></I></H3>
<FORM ACTION="$selfurl" METHOD="post">
	<INPUT TYPE="hidden" NAME="poll" VALUE="$pollname">
	<INPUT TYPE="hidden" NAME="action" VALUE="vote">
<TABLE BORDER="4" CELLPADDING="15">
	<TR>
		<TD><FONT FACE="$font"><B>$polltitle</B><P>
		<I>$pollquestion</I><BR>
		$separator
		<CENTER>
		<TABLE BORDER="0" CELLSPACING="5" CELLPADDING="5">
	;

	# Ausgabe der Optionen
	for($i=1; $i<=$pollnumoptions; $i++)
	{
		print qq
			<TR>
				<TD ALIGN=RIGHT><INPUT TYPE="radio" NAME="option" VALUE="$i"></TD>
				<TH ALIGN="left"><FONT FACE="$font">$polloptions[$i]</FONT></TD>
			</TR>
		;
	}

	print qq
		</TABLE>
		$separator
		<INPUT TYPE="SUBMIT" VALUE="Abstimmen">
		</CENTER>
		</TD>
	</TR>
</TABLE>
</FORM>
<CENTER></DIV>
	;
}


# readpollfile
# Einlesen der von der Verweis-URL in $datafile vorhandenen Daten
#
# Rueckgabewert: $polltitle, $pollquestion, $pollvotes, $polloptions
sub readpollfile
{
	open(DATA,$datafile);
	@datalines = <DATA>;
	close(DATA);

	$tally = 0;

	foreach $dataline (@datalines)
	{
		chomp($dataline);
		$lcdata = lc($dataline);
       
		@splitdata = split(/=/,$dataline);

		if ( substr($lcdata,0,5) eq 'title' )
		{
			$polltitle = $splitdata[1];
		}
		if ( substr($lcdata,0,8) eq 'question' )
		{
			$pollquestion = $splitdata[1];
		}
		if ( substr($lcdata,0,5) eq 'votes' )
		{
			$tindex = substr($splitdata[0],6);
			$pollvotes[$tindex] = $splitdata[1];
			$tally = $tally + $pollvotes[$tindex];
		}
		if ( substr($lcdata,0,6) eq 'option' )
		{
			$tindex = substr($splitdata[0],7);
			$polloptions[$tindex] = $splitdata[1];
		}
		if ( substr($lcdata,0,5) eq 'ipadr' )
		{
			$pollipstring = $splitdata[1];
			@pollips =split(/\|/, $pollipstring);
		}
	}

	$pollnumoptions = scalar(@polloptions) - 1;
}


# writepollfile
# Schreibt die angegebene Datendatei
sub writepollfile
{
	# Ueberschreiben ...
	open(DATA,">$datafile");

	print DATA "title=$polltitle\n";
	print DATA "question=$pollquestion\n";

	for($i=1; $i<=$pollnumoptions; $i++)
	{
		print DATA "votes.$i=$pollvotes[$i]\n";
		print DATA "option.$i=$polloptions[$i]\n";
	}

	if($pollipstring)
	{
		print DATA "ipadr=$pollipstring\|$remaddr\n";
	}
	else
	{
		print DATA "ipadr=$remaddr\n";
	}
	close(DATA);
}


# readdatafile
# Liest die Abstimmungsbeschreibung aus der Datenbank
#
# Rueckgabewert: @allpollnames, %allpolltitles, %allpollfiles, %allpollstatus
sub readdatafile
{
	open(DATA,$polldatafile);
	@datalines = <DATA>;
	close(DATA);

	$curpoll = "";

	@allpollnames = ();

	foreach $dataline (@datalines)
	{
		chomp($dataline);
		$lcdata = lc($dataline);

		@splitdata = split(/=/,$dataline);

		if ( substr($lcdata,0,4) eq 'name' )
		{
			$curpoll = $splitdata[1];
			push(@allpollnames, $curpoll);
		}
		if ( substr($lcdata,0,5) eq 'title' )
		{
			$allpolltitles{"$curpoll"} = $splitdata[1];
		}
		if ( substr($lcdata,0,4) eq 'file' )
		{
			$allpollfiles{"$curpoll"} = $splitdata[1];
		}
		if ( substr($lcdata,0,6) eq 'status' )
		{
			$allpollstatus{"$curpoll"} = $splitdata[1];
		}
	}
	@allpollnames = reverse(@allpollnames);
}


# writedatafile
# Schreibt die aktuellen Inhalte in die Datendatei
sub writedatafile
{
	open(DATA, ">$polldatafile");

	# Umgekehrte Reihenfolge - somit chronologisch
	@allpollnames = reverse(@allpollnames);

	foreach $pname (@allpollnames)
	{
		print DATA "name=$pname\n";
		print DATA "title=$allpolltitles{$pname}\n";
		print DATA "file=$allpollfiles{$pname}\n";
		print DATA "status=$allpollstatus{$pname}\n";
	}

	close(DATA);

	# Umgekehrt wieder zurueck zur 'korrekten' Reihenfolge
	@allpollnames = reverse(@allpollnames);
}


# HTML-Kopf
sub printhtmlhead
{
	local($titel) = $_[0];
	$titel = $title unless $titel;

	print qq
<HTML>
<HEAD>
<TITLE>$titel</TITLE>
<BASE TARGET="_self">
</HEAD>
$bodystyle
<TABLE BORDER="0" WIDTH="100%">
	<TR>
		<TD><H2><FONT FACE="$font" COLOR="#003366">$titel</FONT></H2></TD>
		<TD ALIGN="right" VALIGN="top"><FONT FACE="$font"><A HREF="javascript:history.back()">Zurck</A></FONT></TD>
	<TR>
</TABLE>
$separator
<FONT FACE="$font">
	;
}


#prints HTML header
sub printack
{
	print("Content-type: text/html\n\n");
}


# Fuss der HTML-Ausgabe
sub printhtmlfoot
{
	print("</FONT>\n</BODY>\n</HTML>\n");
}


# read parameters
# Name/Wert-Paare in %form_data (globaler) Hash
sub readparam
{
	if ( ($ENV{'REQUEST_METHOD'} eq 'POST') || ($ENV{'REQUEST_METHOD'} eq 'post') )
	{
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});          #read for POST method to $buffer
		@cgiPairs = split(/\&/,$buffer);
	}
	else
	{
		#get the pairs of parameters passed to the script      for GET method
		@cgiPairs = split(/\&/,$ENV{'QUERY_STRING'}); 
	}

	#split the pairs into a %form_data hash
	foreach $pair ( @cgiPairs )
	{
		($var,$val) = split("=",$pair);
		$val =~ s/\+/ /g;
		$val =~ s/%(..)/pack("c",hex($1))/ge;

		# Fuer Textfelder zur Ersetzung von Zeilenumbruechen
		$val =~ s/\r|\n\r|\r\n/\n/g;
		$val =~ s/\n+/\n/g;

		$form_data{"$var"} = "$val";
	}
}

# Umgebungs- und Formularvariable ausgeben
sub putenv
{
	foreach $key (keys(%ENV))
	{
		print "$key = $ENV{$key}<BR>\n";
	}
	print "<P>\n";
	foreach $key (keys(%form_data))
	{
		print "$key = $form_data{$key}<BR>\n";
	}
}

